package com.mgmtp.insurance.web.component.xform.include;

import java.io.ByteArrayOutputStream;
import java.io.IOException;

import javax.servlet.ServletOutputStream;

/**
 * ServletOutputStream that buffers all output into a ByteArrayOutputStream
 */
public class ByteArrayServletOutputStream extends ServletOutputStream {
	protected ByteArrayOutputStream byteStream;

	private byte[] _buf = new byte[ 1];

	public ByteArrayServletOutputStream() {
		byteStream = new ByteArrayOutputStream();
	}
	
	public byte[] getBytes() {
		return byteStream.toByteArray();
	}

	@Override
	public void close() throws IOException {
		byteStream.close();
//		byteStream = null;
	}

	@Override
	public void flush() throws IOException {
		byteStream.flush();
	}

	@Override
	public void write( byte[] b) throws IOException {
		byteStream.write( b);
	}

	@Override
	public void write( byte[] b, int off, int len) throws IOException {
		byteStream.write( b, off, len);
	}

	@Override
	public synchronized void write( int b) throws IOException {
		_buf[ 0] = (byte) b;
		write( _buf);
	}
}
