package com.mgmtp.insurance.web.component.xform.include;

import javax.el.ValueExpression;
import javax.faces.component.UIInput;

/**
 * A new component to xForm files. 
 * 
 * @author Jan Matz
 * @date $LastChangedDate$
 * @revision $LastChangedRevision$
 */
public class IncludeXFormTag extends UIInput {

	public static final String COMPONENET_TYPE = "IncludeXFormTag";
	public static final String DEFAULT_RENDERER_TYPE = "IncludeXFormTagRenderer";
	public static final String COMPONENT_FAMILY = "IncludeXFormTagFamily";

	private boolean rendered = true;
	private boolean renderedSet = false;
	
	private String template = null;
	private boolean templateSet = false;
	
	Object[] state = null;
	
	public IncludeXFormTag() {
		super();
	}

	public String getFamily() {
		return COMPONENT_FAMILY;
	}

	public String getRendererType() {
		return DEFAULT_RENDERER_TYPE;
	}
	
	public boolean isRendered() {
		if(this.renderedSet){
			return this.rendered;
		}
		ValueExpression ve = getValueExpression("rendered");
		if(ve != null){
			return(Boolean.TRUE.equals(ve.getValue(getFacesContext().getELContext())));
		}
		return this.rendered;
	}

	public void setRendered(boolean rendered) {
		this.rendered = rendered;
		this.renderedSet = true;
	}
	
	public void setTemplate(String template){
		this.template = template;
		this.templateSet = true;
	}
	
	public String getTemplate(){
		//If the template is already set, just return it.
		if(templateSet){
			return this.template;
		}
		//Try reading the attribute template.
		ValueExpression ve = getValueExpression("template");
		if(ve != null){
			//Read the attribute template and set it.
			this.template = (String)ve.getValue(getFacesContext().getELContext());
			this.templateSet = true;
		}
		
		//return the template
		return this.template;
	}
	
}
